
/*	$Id: bnews-protocol-getfilename.c,v 1.1 2002/07/21 12:19:14 stef Exp $ */

#include "bnews.h"

#define min(a,b) ((a)>(b)?(b):(a))

/*
// Check if this is the start of the data stream:
// format should be <<BPST File=[filename] Size=nnnn !BPST>>
*/

int GetFileName(char *buf, char *fname, long int *fsize)
{
    char *p, *p2;
    if (strncasecmp(buf, "<<BPST", 6))
	return 0;
    p = strstr(buf, "File=[");
    if (p == NULL) {
	fprintf(stderr,
	    "Invalid file information in input stream: filename missing.\n");
	exit(2);
    }
    p += 6;
    // to make sure we find only the LAST ] occurrance. 
    // This may break future extensions!
    p2 = strstr(p, "] Size=");
    if (p2 == NULL) {
	fprintf(stderr,
	    "Invalid file information in input stream: filename not terminated.\n");
	 exit(3);
    }
    strncpy(fname, p, min(PATHSIZE, p2 - p));

    p = strstr(buf, "Size=");
    if (p == NULL) {
	fprintf(stderr,
		"Invalid file information in input stream: size missing.\n");
	exit(4);
    }
    sscanf(p + 5, "%ld", fsize);

    return 1;
}

